import java.util.*;
import java.util.stream.*;

public class Sample {
  public static void print(Stream<Integer> stream) {
    stream.forEach(System.out::println);
  }

  public static void main(String[] args) {
    var numbers = List.of(10, 20, 31, 40, 51, 60, 70, 90);

    print(numbers.stream()
      .filter(number -> number > 50));

    //System.out.println("-------");
    //print(numbers.stream()
    //  .filter(number -> number > 50)
    //  .findFirst()); //ERROR

    // Stream may have 0, 1, or any number of values
    // Optional may have 0 or 1 value
    // We may consider an Option as a special case of a Stream from the iteration point of view.

    System.out.println("-------");
    print(numbers.stream()
      .filter(number -> number > 50)
      .findFirst()
      .stream());
  }
}

