import java.util.*;
import java.util.stream.*;

public class Sample {
  public static void main(String[] args) {
    var numbers = List.of(10, 20, 31, 40, 51, 60, 70, 90);

    var result = numbers.stream()
      .filter(number -> number > 150)
      .findFirst();


    System.out.println(result);

    //What does Optional really provide for us?
    //We want to prevent accidental NullPointerException
    //(theory) Optional forces us to check for the value and then use it.

    //How do we get the value out of the Optional?
    System.out.println(result.orElse(0)); //Nice and prefered function


    //System.out.println(result.get()); //bad idea

    System.out.println(result.orElseThrow());  
  }
}

