import java.util.*;
import static java.util.stream.Collectors.*;

public class Sample {
  public static void main(String[] args) {
    var numbers = List.of(10, 20, 31, 40, 51, 60, 71, 90);

    //find the total of even numbers
    var result1 = numbers.stream()
      .filter(number -> number % 2 == 0)
      .mapToInt(number -> number)
      .sum();
    System.out.println(result1);

    //find the total of odd numbers
    var result2 = numbers.stream()
      .filter(number -> number % 2 != 0)
      .mapToInt(number -> number)
      .sum();
    System.out.println(result2);

    //we iterated twice and duplicated code.

    record SumValues(int evenSum, int oddSum) {} 

    var result = numbers.stream()
      .collect(
        teeing(
          summingInt(number -> number % 2 == 0 ? number : 0),
          summingInt(number -> number % 2 != 0 ? number : 0),
	  (evenSum, oddSum) -> new SumValues(evenSum, oddSum)));
    System.out.println(result);
  }
}

